.TH PYTHON "19 February 1991"
.SH NAME
python \(en an extensible interpreted programming language
.SH SYNOPSIS
.B python
[
.I X11-options
] [
.I script
[
.I arguments
] ]
.SH DESCRIPTION
Python is an extensible interpreted programming language that
combines remarkable power with very clear syntax.
For an introduction to programming in Python you are referred to the
Python Tutorial.
.PP
The interpreter operates somewhat like the UNIX shell: when called with
standard input connected to a tty device, it reads and executes commands
interactively until an EOF is read;
when called with a file name argument or with a file as standard
input, it reads and executes a
.I script
from that file.
If available, the script name and additional arguments thereafter are
passed to the script in the variable
.I sys.argv ,
which is a list of strings.
In interactive mode, the primary prompt is `>>>'; the second prompt
(which appears when a command is not complete) is `...'.
.SH FILES AND DIRECTORIES
.IP /usr/local/lib/python
This might be the directory containing the library of standard modules.
(Installation-dependent.)
.SH ENVIRONMENT VARIABLES
.IP PYTHONPATH
Sets the search path for module files.
The format is the same as the shell's $PATH: one or more directory
pathnames separated by colons.
Non-existant directories are silently ignored.
The default search path is installation dependent, but always begins
with `.', (for example,
.I .:/usr/local/lib/python ).
.SH SEE ALSO
Python Tutorial
.br
Python Library Reference
.SH AUTHOR
.nf
Guido van Rossum
CWI, dept. CST
Kruislaan 413
1098 SJ  Amsterdam
The Netherlands
.PP
E-mail: guido@cwi.nl
.fi
.SH COPYRIGHT
Copyright 1991 by Stichting Mathematisch Centrum, Amsterdam, The
Netherlands.
.IP " "
All Rights Reserved
.PP
Permission to use, copy, modify, and distribute this software and its 
documentation for any purpose and without fee is hereby granted, 
provided that the above copyright notice appear in all copies and that
both that copyright notice and this permission notice appear in 
supporting documentation, and that the names of Stichting Mathematisch
Centrum or CWI not be used in advertising or publicity pertaining to
distribution of the software without specific, written prior permission.

STICHTING MATHEMATISCH CENTRUM DISCLAIMS ALL WARRANTIES WITH REGARD TO
THIS SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND
FITNESS, IN NO EVENT SHALL STICHTING MATHEMATISCH CENTRUM BE LIABLE
FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT
OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
